Attribute VB_Name = "Module2"
' ===========================================
' Boulder Dash Game !
'    version 2.00
'
' The task of this game is to collect diamonds
' and avoid ugly butter-flies. You have dodge
' around stones, and make sure they do not fall
' on you. Can play alone or two player game.
' Second player can be on another computer
'  TCP/IP via Internet or LAN
' (Previous Direct cable connection version is available separatly).

'
' This code is free to use for any purpose,
' you should keep the original copyright:
'
' Copyright (C) 2003 Free Code
' http://www.emu8086.com/vb/
'
' For comments: info@emu8086.com
' ===========================================
'
' Check for an update here:
'
'  http://www.emu8086.com/vb/
'
'
Option Explicit

Public Const MAX_COL = 15 '7
Public Const MAX_ROW = 10 '5

' "True" when game is over for both players,
'  or for single player in single player mode:
Public bGameOver As Boolean
' "True" when game is over for player 1 or 2:
Public bGameOverPlayer1 As Boolean
Public bGameOverPlayer2 As Boolean


Public Sub prepare_GAME_FIELD(ByRef pic As PictureBox)
    ' prepare (resize) the field picture box:
    '  starting from zero, so "+1":
    '   also correction for the 3d border around the picture:
    pic.Width = frmDATA.picEven.Width * (MAX_COL + 1) + (pic.Width - pic.ScaleWidth)
    pic.Height = frmDATA.picEven.Height * (MAX_ROW + 1) + (pic.Height - pic.ScaleHeight)
    
    
    ' IMP: both scales (form and pic) should be set to vbPixels!
End Sub


' used to load "KLUM" into data, in case of errors this could
'  help load the file and resave it (also - version convetion):
Public Sub resetNETUNIM(ByRef NETUNIM() As String)
     Dim X As Integer
     Dim Y As Integer
     
     For Y = 0 To MAX_ROW
            For X = 0 To MAX_COL
                NETUNIM(X, Y) = "KLUM"
            Next X
     Next Y
End Sub


Public Sub toenKovecRama(sShemKovec As String, ByRef NETUNIM() As String, ByRef ish_x As Integer, ByRef ish_y As Integer, ByRef p2_x As Integer, ByRef p2_y As Integer, ByRef diamondsLeftToPickUp As Integer)

    On Error GoTo error_found
    
    resetNETUNIM NETUNIM
    
    Dim fNum As Integer
    
    fNum = FreeFile

    Open App.Path & "\" & sShemKovec For Input As fNum
    
     Dim X As Integer
     Dim Y As Integer
     Dim s As String
     Dim ch As String
     
     
     diamondsLeftToPickUp = 0
     iCREATURE_COUNT = 0
     
     
     For Y = 0 To MAX_ROW
     

        Line Input #fNum, s
        
        For X = 0 To MAX_COL
        

            ch = getCharAt(s, X)
            
            ' "BONUS" isn't saved/loaded to/from file.
            
            Select Case ch
            Case "K"
               NETUNIM(X, Y) = "KLUM"
            Case "E"
               NETUNIM(X, Y) = "EVEN"
            Case "H"
               NETUNIM(X, Y) = "HOL"
            Case "B"
               NETUNIM(X, Y) = "BRICKS"
               
            Case "Y"
               NETUNIM(X, Y) = "YALOM"
               diamondsLeftToPickUp = diamondsLeftToPickUp + 1

            Case "C"
               NETUNIM(X, Y) = "CREATURE"
               ReDim Preserve CREATURES(0 To iCREATURE_COUNT + 1)
               CREATURES(iCREATURE_COUNT).iX = X
               CREATURES(iCREATURE_COUNT).iY = Y
               CREATURES(iCREATURE_COUNT).sDirection = GenerateRandomDirection()
               iCREATURE_COUNT = iCREATURE_COUNT + 1
               
            Case "I"
               If Not bGameOverPlayer1 Then
                    NETUNIM(X, Y) = "ISH"
                    ish_x = X
                    ish_y = Y
               End If

            End Select
            
        Next X
     Next Y
     
    ' in case of two player mode second player
    '   is always placed to the right of the first
    '    player:
    If bTWO_PLAYER_MODE Then
        If Not bGameOverPlayer2 Then
            If ish_x > 0 Then ' put second man (BET) at the left side.
                ' in case there was a diamond remove it also from the
                '   counter (to avoid unpassable levels):
                If NETUNIM(ish_x - 1, ish_y) = "YALOM" Then
                    diamondsLeftToPickUp = diamondsLeftToPickUp - 1
                End If
                NETUNIM(ish_x - 1, ish_y) = "P2"
                p2_x = ish_x - 1
                p2_y = ish_y
            Else ' no place at the left side (ALEF), so
                 '        place at the right side:
                ' in case there was a diamond remove it also from the
                '   counter (to avoid unpassable levels):
                If NETUNIM(ish_x + 1, ish_y) = "YALOM" Then
                    diamondsLeftToPickUp = diamondsLeftToPickUp - 1
                End If
                NETUNIM(ish_x + 1, ish_y) = "P2"
                p2_x = ish_x + 1
                p2_y = ish_y
            End If
        End If
    End If
          

    Close #fNum
     

    Exit Sub
error_found:
    Close #fNum ' close anyway.
    MsgBox "Error loading: " & Err.Description
End Sub

' returns TRUE when file exists, and FALSE if it's not:
Public Function FileExists(ByVal sFileName As String) As Boolean
Dim i As Integer
On Error GoTo NotFound
    i = GetAttr(sFileName)
    
FileExists = True

Exit Function
NotFound:
    FileExists = False
    
End Function
